package stringgrid;

import fi.jyu.mit.fxgui.StringGrid;
import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.layout.BorderPane;
import javafx.stage.Stage;

/**
 * Esimerkki Harrastus-olioiden käyttämisestä StringGridissä
 * @author vesal
 * @version 17.2.2019
 */
public class Olio extends Application {
    @Override
    public void start(Stage primaryStage) {
        final BorderPane root = new BorderPane();
        StringGrid<Harrastus> grid = new StringGrid<>();
        root.setCenter(grid);
        alusta(grid);
        primaryStage.setScene(new Scene(root));
        primaryStage.setTitle("Esimerkki");
        primaryStage.show();
    }

    
    private void alusta(StringGrid<Harrastus> grid) {
        String[] headings = {"ala","aloitusvuosi","h/vko"};
        grid.initTable(headings);
        grid.setColumnSortOrderNumber(1);
        grid.setColumnSortOrderNumber(2);
        
        Harrastus harrastus = new Harrastus("kalastus", 1955, 15);
        String[] rivi = new String[3];
        for (int k=0; k < rivi.length; k++)
            rivi[k] = harrastus.anna(k);
        grid.add(harrastus, rivi);
    }


    private static class Harrastus {
        private String ala;
        private int aloitusvuosi;
        private int tuntiaViikossa;
        public Harrastus(String ala, int aloitusvuosi, int tuntiaViikossa) {
            this.ala = ala; 
            this.aloitusvuosi = aloitusvuosi; 
            this.tuntiaViikossa = tuntiaViikossa;
        }
        
        public String anna(int i) {
            switch (i) {
                case 0: return ala;
                case 1: return ""+aloitusvuosi;
                case 2: return ""+tuntiaViikossa;
                default: break;
            }
            return "";
        }
    }
    
    
    /**
     * Käynnistetään käyttöliittymä 
     * @param args komentorivin parametrit
     */
    public static void main(String[] args) {
        launch(args);
    }
}